Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Classification/ClassificationEnsembleSolution.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Classification/ClassificationEnsembleSolution.cs	(revision 8166)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Classification/ClassificationEnsembleSolution.cs	(revision 8167)
@@ -37,7 +37,6 @@
   [Creatable("Data Analysis - Ensembles")]
   public sealed class ClassificationEnsembleSolution : ClassificationSolution, IClassificationEnsembleSolution {
-    private readonly Dictionary<int, double> trainingEstimatedValuesCache = new Dictionary<int, double>();
-    private readonly Dictionary<int, double> testEstimatedValuesCache = new Dictionary<int, double>();
-    private readonly Dictionary<int, double> estimatedValuesCache = new Dictionary<int, double>();
+    private readonly Dictionary<int, double> trainingEvaluationCache = new Dictionary<int, double>();
+    private readonly Dictionary<int, double> testEvaluationCache = new Dictionary<int, double>();
 
     public new IClassificationEnsembleModel Model {
@@ -153,13 +152,13 @@
       get {
         var rows = ProblemData.TrainingIndices;
-        var rowsToEvaluate = rows.Except(trainingEstimatedValuesCache.Keys);
+        var rowsToEvaluate = rows.Except(trainingEvaluationCache.Keys);
         var rowsEnumerator = rowsToEvaluate.GetEnumerator();
         var valuesEnumerator = GetEstimatedValues(rowsToEvaluate, (r, m) => RowIsTrainingForModel(r, m) && !RowIsTestForModel(r, m)).GetEnumerator();
 
         while (rowsEnumerator.MoveNext() & valuesEnumerator.MoveNext()) {
-          trainingEstimatedValuesCache.Add(rowsEnumerator.Current, valuesEnumerator.Current);
+          trainingEvaluationCache.Add(rowsEnumerator.Current, valuesEnumerator.Current);
         }
 
-        return rows.Select(row => trainingEstimatedValuesCache[row]);
+        return rows.Select(row => trainingEvaluationCache[row]);
       }
     }
@@ -168,13 +167,13 @@
       get {
         var rows = ProblemData.TestIndices;
-        var rowsToEvaluate = rows.Except(testEstimatedValuesCache.Keys);
+        var rowsToEvaluate = rows.Except(testEvaluationCache.Keys);
         var rowsEnumerator = rowsToEvaluate.GetEnumerator();
         var valuesEnumerator = GetEstimatedValues(rowsToEvaluate, RowIsTestForModel).GetEnumerator();
 
         while (rowsEnumerator.MoveNext() & valuesEnumerator.MoveNext()) {
-          testEstimatedValuesCache.Add(rowsEnumerator.Current, valuesEnumerator.Current);
+          testEvaluationCache.Add(rowsEnumerator.Current, valuesEnumerator.Current);
         }
 
-        return rows.Select(row => testEstimatedValuesCache[row]);
+        return rows.Select(row => testEvaluationCache[row]);
       }
     }
@@ -208,5 +207,5 @@
 
     public override IEnumerable<double> GetEstimatedClassValues(IEnumerable<int> rows) {
-      var rowsToEvaluate = rows.Except(estimatedValuesCache.Keys);
+      var rowsToEvaluate = rows.Except(evaluationCache.Keys);
       var rowsEnumerator = rowsToEvaluate.GetEnumerator();
       var valuesEnumerator = (from xs in GetEstimatedClassValueVectors(ProblemData.Dataset, rowsToEvaluate)
@@ -215,8 +214,8 @@
 
       while (rowsEnumerator.MoveNext() & valuesEnumerator.MoveNext()) {
-        estimatedValuesCache.Add(rowsEnumerator.Current, valuesEnumerator.Current);
-      }
-
-      return rows.Select(row => estimatedValuesCache[row]);
+        evaluationCache.Add(rowsEnumerator.Current, valuesEnumerator.Current);
+      }
+
+      return rows.Select(row => evaluationCache[row]);
     }
 
@@ -244,7 +243,7 @@
 
     protected override void OnProblemDataChanged() {
-      trainingEstimatedValuesCache.Clear();
-      testEstimatedValuesCache.Clear();
-      estimatedValuesCache.Clear();
+      trainingEvaluationCache.Clear();
+      testEvaluationCache.Clear();
+      evaluationCache.Clear();
 
       IClassificationProblemData problemData = new ClassificationProblemData(ProblemData.Dataset,
@@ -277,14 +276,14 @@
       classificationSolutions.AddRange(solutions);
 
-      trainingEstimatedValuesCache.Clear();
-      testEstimatedValuesCache.Clear();
-      estimatedValuesCache.Clear();
+      trainingEvaluationCache.Clear();
+      testEvaluationCache.Clear();
+      evaluationCache.Clear();
     }
     public void RemoveClassificationSolutions(IEnumerable<IClassificationSolution> solutions) {
       classificationSolutions.RemoveRange(solutions);
 
-      trainingEstimatedValuesCache.Clear();
-      testEstimatedValuesCache.Clear();
-      estimatedValuesCache.Clear();
+      trainingEvaluationCache.Clear();
+      testEvaluationCache.Clear();
+      evaluationCache.Clear();
     }
 
@@ -309,7 +308,7 @@
       testPartitions[solution.Model] = solution.ProblemData.TestPartition;
 
-      trainingEstimatedValuesCache.Clear();
-      testEstimatedValuesCache.Clear();
-      estimatedValuesCache.Clear();
+      trainingEvaluationCache.Clear();
+      testEvaluationCache.Clear();
+      evaluationCache.Clear();
     }
 
@@ -320,7 +319,7 @@
       testPartitions.Remove(solution.Model);
 
-      trainingEstimatedValuesCache.Clear();
-      testEstimatedValuesCache.Clear();
-      estimatedValuesCache.Clear();
+      trainingEvaluationCache.Clear();
+      testEvaluationCache.Clear();
+      evaluationCache.Clear();
     }
   }
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionEnsembleSolution.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionEnsembleSolution.cs	(revision 8166)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionEnsembleSolution.cs	(revision 8167)
@@ -37,7 +37,6 @@
   [Creatable("Data Analysis - Ensembles")]
   public sealed class RegressionEnsembleSolution : RegressionSolution, IRegressionEnsembleSolution {
-    private readonly Dictionary<int, double> trainingEstimatedValuesCache = new Dictionary<int, double>();
-    private readonly Dictionary<int, double> testEstimatedValuesCache = new Dictionary<int, double>();
-    private readonly Dictionary<int, double> estimatedValuesCache = new Dictionary<int, double>();
+    private readonly Dictionary<int, double> trainingEvaluationCache = new Dictionary<int, double>();
+    private readonly Dictionary<int, double> testEvaluationCache = new Dictionary<int, double>();
 
     public new IRegressionEnsembleModel Model {
@@ -158,13 +157,13 @@
       get {
         var rows = ProblemData.TrainingIndices;
-        var rowsToEvaluate = rows.Except(trainingEstimatedValuesCache.Keys);
+        var rowsToEvaluate = rows.Except(trainingEvaluationCache.Keys);
         var rowsEnumerator = rowsToEvaluate.GetEnumerator();
         var valuesEnumerator = GetEstimatedValues(rowsToEvaluate, (r, m) => RowIsTrainingForModel(r, m) && !RowIsTestForModel(r, m)).GetEnumerator();
 
         while (rowsEnumerator.MoveNext() & valuesEnumerator.MoveNext()) {
-          trainingEstimatedValuesCache.Add(rowsEnumerator.Current, valuesEnumerator.Current);
+          trainingEvaluationCache.Add(rowsEnumerator.Current, valuesEnumerator.Current);
         }
 
-        return rows.Select(row => trainingEstimatedValuesCache[row]);
+        return rows.Select(row => trainingEvaluationCache[row]);
       }
     }
@@ -173,13 +172,13 @@
       get {
         var rows = ProblemData.TestIndices;
-        var rowsToEvaluate = rows.Except(testEstimatedValuesCache.Keys);
+        var rowsToEvaluate = rows.Except(testEvaluationCache.Keys);
         var rowsEnumerator = rowsToEvaluate.GetEnumerator();
         var valuesEnumerator = GetEstimatedValues(rowsToEvaluate, RowIsTestForModel).GetEnumerator();
 
         while (rowsEnumerator.MoveNext() & valuesEnumerator.MoveNext()) {
-          testEstimatedValuesCache.Add(rowsEnumerator.Current, valuesEnumerator.Current);
+          testEvaluationCache.Add(rowsEnumerator.Current, valuesEnumerator.Current);
         }
 
-        return rows.Select(row => testEstimatedValuesCache[row]);
+        return rows.Select(row => testEvaluationCache[row]);
       }
     }
@@ -213,5 +212,5 @@
 
     public override IEnumerable<double> GetEstimatedValues(IEnumerable<int> rows) {
-      var rowsToEvaluate = rows.Except(estimatedValuesCache.Keys);
+      var rowsToEvaluate = rows.Except(evaluationCache.Keys);
       var rowsEnumerator = rowsToEvaluate.GetEnumerator();
       var valuesEnumerator = (from xs in GetEstimatedValueVectors(ProblemData.Dataset, rowsToEvaluate)
@@ -220,8 +219,8 @@
 
       while (rowsEnumerator.MoveNext() & valuesEnumerator.MoveNext()) {
-        estimatedValuesCache.Add(rowsEnumerator.Current, valuesEnumerator.Current);
-      }
-
-      return rows.Select(row => estimatedValuesCache[row]);
+        evaluationCache.Add(rowsEnumerator.Current, valuesEnumerator.Current);
+      }
+
+      return rows.Select(row => evaluationCache[row]);
     }
 
@@ -244,7 +243,7 @@
 
     protected override void OnProblemDataChanged() {
-      trainingEstimatedValuesCache.Clear();
-      testEstimatedValuesCache.Clear();
-      estimatedValuesCache.Clear();
+      trainingEvaluationCache.Clear();
+      testEvaluationCache.Clear();
+      evaluationCache.Clear();
       IRegressionProblemData problemData = new RegressionProblemData(ProblemData.Dataset,
                                                                      ProblemData.AllowedInputVariables,
@@ -276,14 +275,14 @@
       regressionSolutions.AddRange(solutions);
 
-      trainingEstimatedValuesCache.Clear();
-      testEstimatedValuesCache.Clear();
-      estimatedValuesCache.Clear();
+      trainingEvaluationCache.Clear();
+      testEvaluationCache.Clear();
+      evaluationCache.Clear();
     }
     public void RemoveRegressionSolutions(IEnumerable<IRegressionSolution> solutions) {
       regressionSolutions.RemoveRange(solutions);
 
-      trainingEstimatedValuesCache.Clear();
-      testEstimatedValuesCache.Clear();
-      estimatedValuesCache.Clear();
+      trainingEvaluationCache.Clear();
+      testEvaluationCache.Clear();
+      evaluationCache.Clear();
     }
 
@@ -308,7 +307,7 @@
       testPartitions[solution.Model] = solution.ProblemData.TestPartition;
 
-      trainingEstimatedValuesCache.Clear();
-      testEstimatedValuesCache.Clear();
-      estimatedValuesCache.Clear();
+      trainingEvaluationCache.Clear();
+      testEvaluationCache.Clear();
+      evaluationCache.Clear();
     }
 
@@ -319,7 +318,7 @@
       testPartitions.Remove(solution.Model);
 
-      trainingEstimatedValuesCache.Clear();
-      testEstimatedValuesCache.Clear();
-      estimatedValuesCache.Clear();
+      trainingEvaluationCache.Clear();
+      testEvaluationCache.Clear();
+      evaluationCache.Clear();
     }
   }